#include <Types.h>
#include <Memory.h>
#include <Quickdraw.h>
#include <Fonts.h>
#include <Events.h>
#include <Menus.h>
#include <Windows.h>
#include <TextEdit.h>
#include <Dialogs.h>
#include <OSUtils.h>
#include <ToolUtils.h>
#include <SegLoad.h>
#include <Resources.h>
#include <Devices.h>

 
#ifndef _LATITUDE_
#include <LGLatitude.h>
#endif
 
#define NIL NULL
#define False  0
#define True   1

#ifdef _LATITUDE_
#define QD(x)	x
#else
#define QD(x)	qd.x
#endif

void InitManagers (void);
Boolean DoCommand(long menu_result);

MenuHandle filemh, applemh;

#define APPLE_MENUID	128
#define APPLE_ABOUT_ITEM 1
#define FILE_MENUID	130
#define FILE_QUIT_ITEM 1

#define ABOUT_UTILS_ALERT	128


#ifndef _LATITUDE_
long 
main(void)
#else
long
main (int argc, char *argv[])
#endif
{
   EventRecord myEvent;
   WindowPtr testwin;
   Boolean quitTime;
   unsigned long menu_result;
   short item_hit;
   unsigned char the_char;

 
#ifdef _LATITUDE_
   LG_APP_INFO_BLOCK info;

   info.flags = LG_APP_INFO_SIGNATURE | LG_APP_INFO_CLASSNAME;
   info.signature = QUADCONST('u','t','i','l');
   info.classname = "Latitude";

   lg_latitude_init(argc, argv, &info);
#endif
 
   InitManagers();

   filemh = GetMenu(FILE_MENUID);
   applemh = GetMenu(APPLE_MENUID);
   AppendResMenu(applemh, QUADCONST('D','R','V','R'));
   InsertMenu(applemh, 0);
   InsertMenu(filemh, 0);
   DrawMenuBar();

   quitTime = False;
 
   while (!quitTime)
   {
		if (!WaitNextEvent(everyEvent, &myEvent, 10, (RgnHandle) NULL))
			continue;
			
		switch (myEvent.what)
		{
			case mouseDown:
				item_hit = FindWindow(myEvent.where, &testwin);
				switch(item_hit)
				{
				    case inMenuBar:
						menu_result = MenuSelect(myEvent.where);
						quitTime = DoCommand(menu_result);
						break;
					default:
						break;
				}
				break;
			case keyDown:
			case autoKey: 
				the_char = myEvent.message & charCodeMask;
				if ((myEvent.modifiers & cmdKey) != 0) 
					quitTime = DoCommand(MenuKey(the_char));
				break;
						
			default:
	    		break; /* do nothing */
		   } 
   } /* while */ 
 
   return (0);
 
}  /* main */
 

void 
InitManagers (void)
{
   MoreMasters();
 
   InitGraf(&QD(thePort));
   InitFonts();
   InitWindows();
   FlushEvents(everyEvent,0);
   InitMenus();
   TEInit();
   InitDialogs(NULL);
   InitCursor();

   return; 
} /* InitManagers */

Boolean 
DoCommand(long menu_result)
{
	Str255 name;
	Boolean quit_selected = False;
	short menu_item;
	
	menu_item = LoWord(menu_result);
	switch (HiWord(menu_result)) 
	{
		case APPLE_MENUID:
			if (menu_item == APPLE_ABOUT_ITEM)
			{
				Alert(ABOUT_UTILS_ALERT, NULL);
			}
			else
			{
				GetMenuItemText(applemh, menu_item, name);
				OpenDeskAcc(name);
			}
			break;
		case FILE_MENUID:
			quit_selected = (menu_item == FILE_QUIT_ITEM);
			break;
		default:
			break;
	}	
	
	HiliteMenu(0);
	return quit_selected;
}
